//sztuczne ognie, od dolu do gory, rozblysk, wygaszenie


#define	TRAP	nop()			// Wycza ledzenie


//#define		TEST_MAIN		// Tylko kugluje PIO w petli main (pomiar obciazenia CPU)
//#define		DMX_ON			// Wcza odbir dmx
//#define		GAMMA_OFF		// Wyczenie korekty gamma
//#define		ECHO_OFF		// Wycza echo dla CMD


#define	TIM_EFEKT_ALL	20001UL//	60000UL		// Gdy nieparzysta to efekty pokolei


char scr_on	= 0b11111111;		// Aktywne ekrany, maska bitowa


#define	MAIN_REFRESH			// Wcza odwierzanie w petli gwnej a nie w IRQ od timera 0


//======================================================================//
#define	BAUD1				1000000
#define	USART1_BITS			7			// 5..9 (FTDI 7..9)
#define	USART1_PARITY		'n'			// 'n', 'e', 'o'
#define	USART1_STOP			1			// 1, 2
//#define	USART1_IRQRX
//#define	USART1_RXBUF	16			// ! Potega dwjki
//#define	USART1_IRQTX
//#define	USART1_TXBUF	16			// ! Potega dwjki

#define	BAUD				1200
#define	USART0_BITS			8			// 5..9 (FTDI 7..9)
#define	USART0_PARITY		'n'			// 'n', 'e', 'o'
#ifdef DMX_ON
  #define	USART0_STOP		2			// 1, 2
#else
  #define	USART0_STOP		1			// 1, 2
#endif
//#define	USART1_IRQRX
//#define	USART1_RXBUF	16			// ! Potega dwjki
//#define	USART1_IRQTX
//#define	USART1_TXBUF	16			// ! Potega dwjki

#include <rmik/include.h>
#include <rmik/usart1.c>
#include <rmik/usart0.c>
#include <rmik/rand.c>


// Miejsce na 64 LEDy. Pasek 60-led.
#define	WSLED		120
#define	EKRANOW		5
#define	SCRLEN		1024


byte VideoA[SCRLEN];
byte *scr;
byte Ekran[EKRANOW][WSLED+1];	// Liczba ekranw (warstw). liczba pozycji (led), skadowe RGB
								// +1 bo bufor na rolowanie ekranw
word volatile pozScr;
byte volatile FL_TransEnd=true, FL_Refresh=true;;


#define	SCR_BLACK		0
#define	SCR_RED			0b10000000
#define	SCR_GREEN		0b01000000
#define	SCR_BLUE		0b00100000
#define	SCR_LEMON		SCR_RED + SCR_GREEN
#define	SCR_YELLOW		SCR_LEMON
#define	SCR_PURPURE		SCR_RED + SCR_BLUE
#define	SCR_AQUA		SCR_GREEN + SCR_BLUE
#define	SCR_WHITE		SCR_RED + SCR_GREEN + SCR_BLUE


#ifndef GAMMA_OFF
  const byte Gamma[32] = {
	0, 1, 2, 2, 3, 3, 4, 5,
	6, 7, 8, 9, 11, 13, 15, 18,
	21, 25, 30, 35, 41, 49, 57, 68,
	80, 94, 111, 131, 155, 183, 216, 255};
#endif
void WS2812B_transcodeRGB(uint8_t green, uint8_t red, uint8_t blue, byte *buffer);   //Przekonwertuj podany kolor w formacie GRB na cig 8 bajtw dla USART
void PrintEkran();
void ClrEkran(  byte scr );
void ClrEkranAll();
void DWrol_Ekran( byte scr );
void DW_Ekran( byte scr );
void UProl_Ekran( byte scr );
void UP_Ekran( byte scr );


void InitDemo_KometyKoloroweRol();

void Demo_ALL();
void Demo_DwieKomety( byte tlo, byte fast );
void Demo_TloGwiazdy();
void Demo_KometyKoloroweRol();
void Demo_KometyPulsowanie();
void Demo_Pulsowanie();
void Demo_Pulsowanie_Pause();
void Demo_Sople();
void Demo_Pociag( byte dir, byte speed );
void Demo_SpadajacaGwiazda( byte tlo );
void Demo_SoplePulsowanie();
void Demo_Gwizady( byte speed );
void Demo_Tetris();

void Tlo4Gwiazdki( byte gestosc, byte speed );
void SopleDolSzybko( byte scr );
void Pociag( byte scr, byte dir, byte speed );
void PulsowanieLosowe( byte scr );
void SpadajacaGwiazda( byte scr );


byte Pulsowanie( byte scr, byte kolor, byte min, byte max );
void KometaUPlos( byte ekran, byte kolor );
byte DemoOff;

void Refresh();


word volatile TimScr[EKRANOW];
long volatile TimerDemo=TIM_EFEKT_ALL;
void InitTimer0();
void InitTimer2();


#define	LENTABDATA	4
byte dmx[LENTABDATA];
byte TabPwm[LENTABDATA];
enum{DMX_OFFLINE, DMX_BREAK };
byte DmxStatus;
void dekoduj_dmx();
word AdrDMX=1;
byte CntDanych;


void Cmd();
//	Ustawienie punktu (wycza demo):
// : xx RR GG BB CR
// gdzue XX - nr led w zakresie 1..60 w DEC
// RR GG BB skadowe koloru w zakresie 0..99 w DEC
// parametry wprowadzac w postaci dwu liczb (z zerem nieznaczcym)


//#if SCRLEN!=256 && SCRLEN!=512 && SCRLEN!=1024 && SCRLEN!=2048 && SCRLEN!=4096 && SCRLEN!=8192
//  #error "SCRLEN musi byc potego 2"
//#endif


enum{ ERR_SCR=1 };
void Error( byte err );
long losowa NOINIT;


//=======================================================================//
#include <rmik/wdgi.c>

long PowerOn NOINIT;

long adrRst NOINIT;
void IrqWdg();


//----------------------------------------------------------------------//
void IrqWdg()
{
TRAP;
/*
char txt[20];


	PrintStringFT201_P( (char*)PSTR(ANSI_PEN_RED""CRLF"********"CRLF""ANSI_PEN_YELLOW) );

	if ( IdSoftReset == DEF_RST_SOFT )
		{
		PrintStringFT201_P( (char*)PSTR("Soft Reset ") );
		}
	else if ( IdSoftReset==DEF_RST_BADIRQ )
		{
		PrintStringFT201_P( (char*)PSTR("Bad IRQ ") );
		}
	else
		{
		PrintStringFT201_P( (char*)PSTR("Wdg Error ") );
		}


	adrRst = adrCallWdg;
word adrL, adrH;
	adrL = adrCallWdg;
	adrH = (adrCallWdg>>8)>>8;
	sprintf_P( txt, (char*)PSTR("$%x%04x"), adrH, adrL ); PrintStringFT201( txt );

	PrintStringFT201_P( (char*)PSTR(CRLF"********"CRLF) );
TRAP;
*/
	while( true ) nop();
}


//=======================================================================//
ISR( BADISR_vect )
{
	IdSoftReset = DEF_RST_BADIRQ;
	//sei(); IrqWdg();
	while( true ) nop();
}


//======================================================================//
void main()
{
//todo: zrobic IRQ od WDG
	wdt_enable( WDTO_500MS );			// Ustawienie WDG (IRQ musz byc wyczone)


	DDRD |= _BV(PD5);					// Led Run
	TCCR1A|= (3<<COM1A0) | (1<<WGM10);	// Fast PWM 8-bit
	TCCR1B |= (1<<CS10);				// Podzielnik


	DDRA |= _BV(PA7);		// XOR
	PORTA |= _BV(PA7);


	Usart0_Init();
	#if F_CPU==20000000 && defined( DMX_ON )
	  UBRR0H = 0; UBRR0L = 4;		// Dla 20MHz 4
	#elif F_CPU==16000000 && defined( DMX_ON )
	  UBRR0H = 0; UBRR0L = 3;		// Dla 16MHz 4
	#else
	  #warning "*** DMX nie bdzie dzialal ***"
	#endif
	#if F_CPU<18000000
	  #warning "Min dla WS2812 to 18MHz"
	#endif

	Usart1_Init();
	UBRR1H = 0; UBRR1L = 0;
	UCSR1A |= _BV(U2X1);		// W trybie SPI nie ma znaczenia
//	UCSR1C |= (1<<UMSEL10);		// Tryb SYNCHRO (1) nie generuje zegara ???
//UBRR1L = 1;
	UCSR1B |= (1<<TXCIE1);		// Wczenie przerwa nadawczych


	_srandom( losowa );
	ClrEkranAll();


//	InitDemo_KometyKoloroweRol();


	InitTimer0();
	InitTimer2();


	scr = VideoA+10;		// Wskanik na ekran A (10 led;w ukryte)
	PrintEkran();
	Refresh();
	sei();


DDRA |= _BV(PA3);
DDRA |= _BV(PA2);
DDRB |= _BV(PB4);
	while( true )
	{
		wdg();
#ifdef TEST_MAIN
loop:
 wdg();
 PORTA |= _BV(PA3);
 PORTA &= ~_BV(PA3);
 goto loop;
#endif


	Cmd();


	if ( FL_Refresh  )			// Jeli koniec transmisji
		{
		FL_Refresh = false;
		if ( !DemoOff )			// Wywietla demo na LED
			{
			Demo_ALL();
//Demo_Pulsowanie_Pause();
//	Demo_SpadajacaGwiazda( 1 );
//	Demo_Pociag( 0, 1 );
//	Demo_DwieKomety( 1, true );
//	Demo_Gwizady( true );
//	Demo_KometyKoloroweRol();
//	Demo_KometyPulsowanie();
//	Demo_Pulsowanie();
//	Demo_Sople();
//	Demo_SoplePulsowanie();

//	Demo_Tetris();
			PrintEkran();
			}
		else					// Dekodowanie rozkazw z USB
			{
TRAP;
			}
		#ifdef MAIN_REFRESH
		  Refresh();
		#endif
		}
	}
}


//======================================================================//
void Error( byte err )
{
TRAP;
	IdSoftReset = DEF_RST_BADIRQ;
	//sei(); IrqWdg();
	while( true ) nop();
}


//======================================================================//
void Cmd()
{
#define	LEDBUF		16
byte static p, buf[LEDBUF];
word znak;
static byte x=-1,r=-1,g=-1,b=-1;


	if( (znak=Usart0_Receive())==NONE ) return;


	if ( znak==':' )
		{
		// "Czy" bufor klawiaruty
		p=0; for(x=0; x<LEDBUF; x++) buf[x]='0';
		// Zatrzymaj animacj i wyczy VIDEO
		if ( !DemoOff )
			{
			DemoOff=true;
			for(byte x=0; x<EKRANOW; x++) ClrEkran( x );
			PrintEkran();
			}
		}


	buf[p++] = znak; p &= LEDBUF-1;
	#ifndef ECHO_OFF
	  Usart0_Transmit( znak );
	#endif


	// Jeli CR to przystp do interpretacji komendy
	if ( znak != CR ) return;


	if ( buf[0] == '@' )
		{
		if ( buf[1]=='0' ) scr_on &= ~0b10000; else scr_on |= 0b10000;
		if ( buf[2]=='0' ) scr_on &= ~0b01000; else scr_on |= 0b01000;
		if ( buf[3]=='0' ) scr_on &= ~0b00100; else scr_on |= 0b00100;
		if ( buf[4]=='0' ) scr_on &= ~0b00010; else scr_on |= 0b00010;
		if ( buf[5]=='0' ) scr_on &= ~0b00001; else scr_on |= 0b00001;
		Usart0_Transmit( 'O' );
		Usart0_Transmit( 'K' );
		Usart0_Transmit( CR );
		Usart0_Transmit( LF );
		}
	else if ( buf[0] == ':' )
		{
//	sscanf_P( buf+1, (char*)PSTR("%d"), &x );
//	sscanf_P( buf+4, (char*)PSTR("%x"), &r );
//	sscanf_P( buf+7, (char*)PSTR("%x"), &g );
//	sscanf_P( buf+10, (char*)PSTR("%x"), &b );
		x= 10*(*(buf+1)-'0') + *(buf+2)-'0';

		r= 10*(*(buf+4)-'0') + *(buf+5)-'0'; r *= 2;
		g= 10*(*(buf+7)-'0') + *(buf+8)-'0'; g *= 2;
		b= 10*(*(buf+10)-'0') + *(buf+11)-'0'; b *= 2;


		if( x>0 && x<WSLED+1 )
			{
			x--;
			WS2812B_transcodeRGB( r, g, b, scr+x*8 );
			Usart0_Transmit( 'O' );
			Usart0_Transmit( 'K' );
			}
		else
			{
			Usart0_Transmit( 'E' );
			Usart0_Transmit( 'r' );
			Usart0_Transmit( 'r' );
			}
		Usart0_Transmit( CR );
		Usart0_Transmit( LF );
		}

TRAP;
}


//======================================================================//
void Demo_ALL()
{
byte static Ekeft=0;


#define		EFEKT_KOMROL	1					// Nie moe byc nr 0 bo wymaga ninitu po zmianie efektu
TRAP;
	switch( Ekeft )
		{
		case (0 ): Demo_TloGwiazdy(); break;
		case( EFEKT_KOMROL ): Demo_KometyKoloroweRol(); break;		// Nie moe byc nr 0 bo wymaga ninitu po zmianie efektu
		case( 2 ): Demo_Gwizady( 1 ); break;
		case( 3 ): Demo_Pociag( 0, 1 ); break;
		case( 4 ): Demo_DwieKomety( 0, false ); break;
		case( 5 ): Demo_Pulsowanie(); break;
		case( 6 ): Demo_Gwizady( 0 ); break;
		case( 7 ): Demo_Pociag( 0, 2 ); break;
		case( 8 ): Demo_DwieKomety( 0, true ); break;
		case( 9 ): Demo_SpadajacaGwiazda( 0 );
		case( 10 ): Demo_Sople(); break;
		case( 11 ): Demo_DwieKomety( 1, false ); break;
		case( 12 ): Demo_Pociag( 1, 1 ); break;
		case( 13 ): Demo_SoplePulsowanie(); break;
		case( 14 ): Demo_Gwizady( 2 ); break;
		case( 15 ): Demo_SpadajacaGwiazda( 1 );
		case( 16 ): Demo_DwieKomety( 1, true ); break;
		case( 17 ): Demo_KometyPulsowanie(); break;
		case( 18 ): Demo_Pociag( 1, 2 ); break;
		case( 19 ): Demo_SpadajacaGwiazda( 2 );
#define	EFEKTOW_DEMO	20
		default:
			TRAP;
			Ekeft=0;
		}


	if( TimerDemo ) return;
	#if TIM_EFEKT_ALL & 1
	  TimerDemo = TIM_EFEKT_ALL;
	  Ekeft++;
	  return;
	#else


	TimerDemo = TIM_EFEKT_ALL + (_random() % 30) * 1000;

	if( Ekeft==EFEKT_KOMROL ) TimerDemo *= 2;		// Ten efekt duej

	Ekeft += 1 + (_random() % EFEKTOW_DEMO);		// Losowanie w zakresie 0..7
	if( Ekeft > (EFEKTOW_DEMO-1) ) Ekeft -= EFEKTOW_DEMO;
	#endif
TRAP;
	ClrEkranAll();						// Zmiana efektu wic czyimy ekran
	switch( Ekeft )
		{
		case( EFEKT_KOMROL ): InitDemo_KometyKoloroweRol(); break;
		}
}


//----------------------------------------------------------------------//
void Demo_DwieKomety( byte tlo, byte fast )
{
fast &= 1; if( fast ) fast=3;


	if( !tlo )
		{
		Tlo4Gwiazdki( 20, 100 );
		}
	else
		{
		Pulsowanie( 4, SCR_BLUE, 16, 128 );

/*
		byte static kolor, PREVkolor;
		if( !TimScr[4] )
			{
			TimScr[4] = 1;
			//
			if( Pulsowanie( 4, (kolor << 5), 0, 80 ) )			// Jeli koniec cyklu
				{
				while( !(kolor=_random() % 7) );
				if( PREVkolor == kolor ) while( !(kolor=_random() % 7) );
				PREVkolor = kolor;
				}
			}
*/
		}



	byte static start2=1, FL_odpal2, koniec2;
	if( !TimScr[2] )
		{
		TimScr[2] = 1;
		//
		byte x=0;
		do {
			if( FL_odpal2>koniec2 )	// Generowanie komety
				{
				FL_odpal2--;
				if(FL_odpal2>=28) Ekran[2][WSLED-1] = SCR_WHITE+(31-FL_odpal2);			// Czoo komety biae
				else if (FL_odpal2>=10) Ekran[2][WSLED-1] = SCR_LEMON+(31-FL_odpal2);
				else Ekran[2][WSLED-1] = SCR_RED+(31-FL_odpal2);
				}
			DW_Ekran( 2 );			// Przeswanie ekranu
TRAP;
			}while( ++x<fast );		// Du predkoc ciko osignc, bo wysanie do WS "troch" trwa, wic przeswamy kilka razy
		start2--;
		if( !start2 )
			{
 			start2=30 + (_random() % 40);
			FL_odpal2 = 31;					// Jasno komety
			koniec2 = (_random() % 5) * 3;	// Dugo (0-najdusza)
			}
		}


	byte static start1=1, FL_odpal1, koniec1;
	if( !TimScr[1] )
		{
		TimScr[1] = 1;
		//
		byte x=0;
		do {
			if( FL_odpal1>koniec1 )	// Generowanie komety
				{
				FL_odpal1--;
				if(FL_odpal1>=28) Ekran[1][0] = SCR_WHITE+(31-FL_odpal1);			// Czoo komety biae
				else if (FL_odpal1>=10) Ekran[1][0] = SCR_LEMON+(31-FL_odpal1);
				else Ekran[1][0] = SCR_RED+(31-FL_odpal1);
				}
			UP_Ekran( 1 );			// Przeswanie ekranu
			}while( ++x<fast );		// Du predkoc ciko osignc, bo wysanie do WS "troch" trwa, wic przeswamy kilka razy
		start1--;
		if( !start1 )
			{
 			start1=30 + (_random() % 40);
			FL_odpal1 = 31;					// Jasno komety
			koniec1 = (_random() % 5) * 3;	// Dugo (0-najdusza)
			}
		}
}


//----------------------------------------------------------------------//
void Demo_TloGwiazdy()
{
	Tlo4Gwiazdki( 30, 10 );
}


//----------------------------------------------------------------------//
void Demo_Gwizady( byte speed )
{
byte static PREVkolor;
byte kolor;


	Tlo4Gwiazdki( 20, 100 );


	if( !TimScr[2] )
		{
		if ( speed==1 ) TimScr[2] = 50;		// 10 razy na sekund
		else if ( speed==2 ) TimScr[2] = 500;	// 2 razy na sekund
		else TimScr[2] = 5000;				// co 5 sekund
		//
		ClrEkran( 2 );
		for(byte x=0; x<WSLED/6; x++)
			{
			while( !(kolor=_random() % 7) );
			if( PREVkolor == kolor ) while( !(kolor=_random() % 10) );
			PREVkolor = kolor;

			byte poz=x*5+(_random() % 21);		// 120led/6 * 5 +20(rnd) =120
			Ekran[2][poz] = kolor<<5;
			}
		}
}


//----------------------------------------------------------------------//
void Demo_Tetris()		//todo: zrobi
{
byte static kolor, PREVkolor, krok=0;


	if( !TimScr[2] )
		{
		TimScr[2] = 1;
		//
		UP_Ekran( 2 );
		//
		while( !(kolor=_random() % 7) );
		if( PREVkolor == kolor ) while( !(kolor=_random() % 7) );
		PREVkolor = kolor;
		}
}


//----------------------------------------------------------------------//
void Demo_SpadajacaGwiazda( byte tlo )
{
	if( tlo==1 ) Tlo4Gwiazdki( 20, 100 );
	  else if ( !tlo ) PulsowanieLosowe( 4 );


	SpadajacaGwiazda( 0 );
	SpadajacaGwiazda( 1 );
	SpadajacaGwiazda( 2 );
	SpadajacaGwiazda( 3 );
}


//----------------------------------------------------------------------//
void SpadajacaGwiazda( byte scr )
{
byte static start[EKRANOW]={1,1,1,1,1}, FL_odpal[EKRANOW], dlugosc[EKRANOW], koniec[EKRANOW], kolor[EKRANOW], PREVkolor[EKRANOW], poz[EKRANOW];


	if( !kolor[scr] )								// Jeli czarny to losuj
		{
		while( !(kolor[scr]=_random() % 8) );
		}


	if( !TimScr[scr] )
		{
		TimScr[scr] = 1;
		//
		for(byte x=0; x<scr; x++)		// Du predkoc ciko osignc, bo wysanie do WS "troch" trwa
			{							// Kada warstwa ma inn predkoc sopadania gwiazdy
			ClrEkran( scr );
			if( dlugosc[scr] )
				{
				dlugosc[scr]--;
				Ekran[scr][WSLED-1-poz[scr]] = (kolor[scr]<<5);
				}
			else if( FL_odpal[scr]>koniec[scr] )
				{
				FL_odpal[scr]--;
				Ekran[scr][WSLED-1-poz[scr]] = (kolor[scr]<<5)+(31-FL_odpal[scr]);
				}
			else start[scr]=1;			// Wymysi start nastpnej gwiazdy
			poz[scr]++;
//			DW_Ekran( scr );		// Przeswanie ekranu
		start[scr]--;
		if( !start[scr] )
			{
 			start[scr]=120-40 + (_random() % 40);
			FL_odpal[scr] = 31;						// Jasno komety
			koniec[scr] = 0;//(_random() % 8) * 3;	// Dugo (0-najdusza)
			dlugosc[scr] = (_random() % WSLED-32);	// Jak dugo spada wiecc pena moc
			poz[scr]=0;

			while( !(kolor[scr]=_random() % 7) );
			if( PREVkolor[scr] == kolor[scr] ) while( !(kolor[scr]=_random() % 7) );
			PREVkolor[scr] = kolor[scr];
TRAP;
			}
			}
		}
}


//----------------------------------------------------------------------//
void Demo_Pociag( byte dir, byte speed )
{
	Pociag( 2, dir, speed );
}


//----------------------------------------------------------------------//
void Pociag( byte scr, byte dir, byte speed )
{
byte static start2=1, FL_odpal, koniec, kolor, PREVkolor;


	if( !kolor )								// Jeli czarny to losuj
		{
		while( !(kolor=_random() % 8) );
		}


//kolor=2;
	if( !TimScr[scr] )
		{
		TimScr[scr] = 1;
		//
		for(byte x=0; x<speed; x++)		// Du predkoc ciko osignc, bo wysanie do WS "troch" trwa
			{
			if( FL_odpal>koniec )
				{
				FL_odpal--;
				if( dir ) Ekran[scr][WSLED-1] = (kolor<<5)+(31-FL_odpal);
				  else Ekran[scr][0] = (kolor<<5)+(31-FL_odpal);
				}
			else start2=1;			// Wymysi start nastpnej komety
			if( dir ) DW_Ekran( scr );		// Przeswanie ekranu
			  else UP_Ekran( scr );		// Przeswanie ekranu
			}
		start2--;
		if( !start2 )
			{
 			start2=10 + (_random() % 40);
			FL_odpal = 31;					// Jasno komety
			koniec = (_random() % 8) * 3;	// Dugo (0-najdusza)

			while( !(kolor=_random() % 7) );
			if( PREVkolor == kolor ) while( !(kolor=_random() % 7) );
			PREVkolor = kolor;
TRAP;
			}
		}
}


//----------------------------------------------------------------------//
void Demo_SoplePulsowanie()
{
	Tlo4Gwiazdki( 20, 100 );
	PulsowanieLosowe( 3 );
	SopleDolSzybko( 2 );
}


//----------------------------------------------------------------------//
void PulsowanieLosowe( byte scr )
{
byte static start2=1, FL_odpal, koniec;
byte static kolor=0, PREVkolor;


	if( !kolor )								// Jeli czarny to losuj
		{
		while( !(kolor=_random() % 8) );
		}
	if( !TimScr[scr] )
		{
		TimScr[scr] = 1;

		if( Pulsowanie( scr, (kolor << 5), 0, 80 ) )			// Jeli koniec cyklu
			{
			while( !(kolor=_random() % 7) );
			if( PREVkolor == kolor ) while( !(kolor=_random() % 7) );
			PREVkolor = kolor;
			}
		}
}


//----------------------------------------------------------------------//
void Demo_Sople()
{
	Tlo4Gwiazdki( 20, 100 );
	SopleDolSzybko(2);
}


//----------------------------------------------------------------------//
void SopleDolSzybko( byte scr )
{
byte static start2=1, FL_odpal, koniec;


	if( !TimScr[scr] )
		{
		TimScr[scr] = 1;
		//
		for(byte x=0; x<4; x++)		// Du predkoc ciko osignc, bo wysanie do WS "troch" trwa
			{
			if( FL_odpal>koniec )
				{
				FL_odpal--;
				Ekran[scr][WSLED-1] = SCR_WHITE+(31-FL_odpal);
				}
				DW_Ekran( scr );	// Przeswanie ekranu
			}
		start2--;
		if( !start2 )
			{
 			start2=10 + (_random() % 40);
			FL_odpal = 31;				// Jasno komety
			koniec = (_random() % 5) * 3;	// Dugo (0-najdusza)
			}
		}
}


//----------------------------------------------------------------------//
void Demo_Pulsowanie()
{
byte static kolor=0, PREVkolor;


	if( !kolor )								// Jeli czarny to losuj
		{
		while( !(kolor=_random() % 8) );
		}
	if( !TimScr[4] )
		{
		TimScr[4] = 1;

		if( Pulsowanie( 4, (kolor << 5), 0, 255 ) )			// Jeli koniec cyklu
			{
			while( !(kolor=_random() % 7) );
			if( PREVkolor == kolor ) while( !(kolor=_random() % 7) );
			PREVkolor = kolor;
			}
		}
}


//----------------------------------------------------------------------//
void Demo_Pulsowanie_Pause()
{
byte static kolor=0;
byte static krok=0;


	if( !kolor ) kolor++;								// Jeli czarny to losuj

	if( !TimScr[4] )
		{
		TimScr[4] = 1;

		if( ++krok >= 32 )
			{
			TRAP;
			if( krok < 250 ) return;
			}


		if( Pulsowanie( 4, (kolor << 5), 0, 255 ) )			// Jeli koniec cyklu
			{
			kolor++; kolor &= 7;
			krok=0;
			}
		}
}


//----------------------------------------------------------------------//
void Demo_KometyPulsowanie()
{
byte static start2=3, start3=10;


	if( !TimScr[4] )
		{
		TimScr[4] = 20;
		Pulsowanie( 4, SCR_BLUE, 16, 128 );
		}


	if( !TimScr[3] )
		{
		TimScr[3] = 20;
		UP_Ekran( 3 );

		start3--;
		if( !start3 )
			{
	 		start3=10 + (_random() % 20);
			KometaUPlos( 3, SCR_WHITE );
		  	}
		}


	if( !TimScr[2] )
		{
		TimScr[2] = 200;

		UP_Ekran( 2 );
		start2--;
		if( !start2 )
			{
	 		start2=30 + (_random() % 20);
			KometaUPlos( 2, SCR_WHITE );
		  	}
		}

}


//----------------------------------------------------------------------//
void KometaUPlos( byte scr, byte kolor )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );

	switch( _random() % 5 )
		{
		case( 0 ):
			Ekran[scr][4] = kolor;
			Ekran[scr][3] = kolor+2;
			Ekran[scr][2] = kolor+4;
			Ekran[scr][1] = kolor+8;
			Ekran[scr][0] = kolor+12;
			break;
		case( 1 ):
			Ekran[scr][3] = kolor+8;
			Ekran[scr][2] = kolor+10;
			Ekran[scr][1] = kolor+12;
			Ekran[scr][0] = kolor+14;
			break;
		case( 2 ):
			Ekran[scr][2] = kolor+10;
			Ekran[scr][1] = kolor+15;
			Ekran[scr][0] = kolor+20;
			break;
		default:
			Ekran[scr][1] = kolor+15;
			Ekran[scr][0] = kolor+20;
		}
}


//----------------------------------------------------------------------//
void InitDemo_KometyKoloroweRol()
{
	ClrEkranAll();


	#define KOMETA1		SCR_WHITE
	Ekran[0][17] = KOMETA1;
	Ekran[0][16] = KOMETA1+8;
	Ekran[0][15] = KOMETA1+12;
	Ekran[0][14] = KOMETA1+16;
	Ekran[0][13] = KOMETA1+20;
	Ekran[0][12] = KOMETA1+24;
	Ekran[0][11] = KOMETA1+28;
	Ekran[0][10] = KOMETA1+31;


	#define	KOMETA2		SCR_AQUA
	Ekran[0][42] = KOMETA2+15;
	Ekran[0][41] = KOMETA2+20;
	Ekran[0][40] = KOMETA2+30;


	Ekran[1][20] = SCR_RED;
	Ekran[1][21] = SCR_RED+4;
	Ekran[1][22] = SCR_RED+8;
	Ekran[1][23] = SCR_RED+15;
	Ekran[1][24] = SCR_RED+20;
	Ekran[1][25] = SCR_RED+25;
	Ekran[1][26] = SCR_RED+31;


	#define	KOMETA3		SCR_LEMON
	Ekran[1][50] = KOMETA3;
	Ekran[1][51] = KOMETA3+4;
	Ekran[1][52] = KOMETA3+8;
	Ekran[1][53] = KOMETA3+15;
	Ekran[1][54] = KOMETA3+20;
	Ekran[1][55] = KOMETA3+25;
	Ekran[1][56] = KOMETA3+31;


	Ekran[2][34] = SCR_BLUE;
	Ekran[2][33] = SCR_BLUE+7;
	Ekran[2][32] = SCR_BLUE+15;
	Ekran[2][31] = SCR_BLUE+20;
	Ekran[2][30] = SCR_BLUE+31;


	Ekran[2][14] = SCR_GREEN;
	Ekran[2][13] = SCR_GREEN+7;
	Ekran[2][12] = SCR_GREEN+15;
	Ekran[2][11] = SCR_GREEN+20;
	Ekran[2][10] = SCR_GREEN+31;


	Ekran[3][40] = SCR_BLUE+20;
	Ekran[3][41] = SCR_BLUE+24;
	Ekran[3][42] = SCR_BLUE+26;
	Ekran[3][43] = SCR_BLUE+28;


	Ekran[3][20] = SCR_PURPURE+20;
	Ekran[3][21] = SCR_PURPURE+24;
	Ekran[3][22] = SCR_PURPURE+26;
	Ekran[3][23] = SCR_PURPURE+28;
}


//----------------------------------------------------------------------//
//		https://www.youtube.com/watch?v=uUD2wJ-_huw
//----------------------------------------------------------------------//
void Demo_KometyKoloroweRol()
{
#define	SPEED	2


	if ( !TimScr[0] )
		{
		TimScr[0] = 100 * SPEED;
		UProl_Ekran(0);
		}
	if ( !TimScr[1] )
		{
		TimScr[1] = 130 * SPEED;
		DWrol_Ekran(1);
		}
	if ( !TimScr[2] )
		{
		TimScr[2] = 160 * SPEED;
		UProl_Ekran(2);
		}
	if ( !TimScr[3] )
		{
		TimScr[3] = 190 * SPEED;
		DWrol_Ekran(3);
		}
	Tlo4Gwiazdki( 20, 100 );
}


//----------------------------------------------------------------------//
void Tlo4Gwiazdki( byte gestosc, byte speed )
{
byte static rol=1, kol[40], ofs[40];


	if( gestosc > 30 ) gestosc = 30;


	if ( !TimScr[4] )						// Gwiazdki
		{
		TimScr[4] = 50;
		if( !rol-- )
			{
			rol=speed;
			ClrEkran( 4 );
			for(byte x=0; x<gestosc; x++)
				{
				kol[x] = ((_random() % 7 ) + 1)<<5;
		  		ofs[x] = _random() % 3;
				}
			}
	#if WSLED<=60
		Ekran[4][5+ofs] =  SCR_WHITE	+ ((odcien++) & 7)+24;
		Ekran[4][10+ofs] = SCR_RED		+ ((odcien++) & 7)+24;
		Ekran[4][15+ofs] = SCR_GREEN	+ ((odcien++) & 7)+24;
		Ekran[4][20+ofs] = SCR_BLUE		+ ((odcien++) & 7)+24;
		Ekran[4][25+ofs] = SCR_LEMON	+ ((odcien++) & 7)+24;
		Ekran[4][30+ofs] = SCR_PURPURE	+ ((odcien++) & 7)+24;
		Ekran[4][35+ofs] = SCR_AQUA		+ ((odcien++) & 7)+24;
		Ekran[4][40+ofs] = SCR_WHITE	+ ((odcien++) & 7)+24;
		Ekran[4][45+ofs] = SCR_RED		+ ((odcien++) & 7)+24;
		Ekran[4][50+ofs] = SCR_BLUE		+ ((odcien++) & 7)+24;
		Ekran[4][55+ofs] = SCR_AQUA		+ ((odcien++) & 7)+24;
		}
	#elif WSLED<=120
		for(word x=0; x<gestosc; x++)
			{
//			if( x!=TLO4_GESTOSC-1)
				Ekran[4][x*(word)(WSLED/gestosc)+ofs[x]] = kol[x]+ ((_random()) & 7)+24;
//			else
//				Ekran[4][x*(word)(WSLED/gestosc)-ofs[x]] = kol[x]+ ((_random()) & 7)+24;
			}
/*
		Ekran[4][2*5+ofs[0]] =  kol[0]	+ ((_random()) & 7)+24;
		Ekran[4][2*10+ofs[1]] = kol[1]	+ ((_random()) & 7)+24;
		Ekran[4][2*15+ofs[2]] = kol[2]	+ ((_random()) & 7)+24;
		Ekran[4][2*20+ofs[3]] = kol[3]	+ ((_random()) & 7)+24;
		Ekran[4][2*25+ofs[4]] = kol[4]	+ ((_random()) & 7)+24;
		Ekran[4][2*30+ofs[5]] = kol[5]	+ ((_random()) & 7)+24;
		Ekran[4][2*35+ofs[6]] = kol[6]	+ ((_random()) & 7)+24;
		Ekran[4][2*40+ofs[7]] = kol[7]	+ ((_random()) & 7)+24;
		Ekran[4][2*45+ofs[8]] = kol[8]	+ ((_random()) & 7)+24;
		Ekran[4][2*50+ofs[9]] = kol[9]	+ ((_random()) & 7)+24;
		Ekran[4][2*55+ofs[10]] = kol[10]+ ((_random()) & 7)+24;
*/
		}
	#endif
}


//======================================================================//
byte Pulsowanie( byte scr, byte kolor, byte min, byte max )
{
byte static jasnosc=0, kierunek=true;


	if( scr >= EKRANOW ) return( false );


	min >>= 3;
	max >>= 3;


byte j, stat=false;
	if( kierunek )
		{
		jasnosc++; 		// Rozjanianie
		if( jasnosc>=max ) kierunek = false;
		}
	else
		{
		jasnosc--;		// ciemianie
		if( jasnosc<=min ){ kierunek = true; stat = true; }
		}
	j = 0x1F - (jasnosc & 0x1F);


	for(word x=0; x<WSLED; x++) Ekran[scr][x] = (kolor & 0b11100000) + (j & 0x1F);


	return( stat );		// Zwraca TRUE gdy osignieto jasno minimaln
}


//----------------------------------------------------------------------//

//======================================================================//
void ClrEkran( byte scr )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );


	for(byte x=0; x<WSLED; x++)
		{
		Ekran[scr][x] = 0;
		}
}


//----------------------------------------------------------------------//
void ClrEkranAll()
{
	for(word x=0; x<SCRLEN; x++)
		{
					// EccBBBaaS
		VideoA[x]	= 0b1011011;	// Czarny
		}
	for(byte x=0; x<EKRANOW; x++) ClrEkran( x );
}


//----------------------------------------------------------------------//
void PrintEkran()
{
byte r,g,b,barwa, jaskrawosc;
byte x,s;


	// Skopiowanie ekranu 0 do pamici video
	for(x=0; x<WSLED; x++)
		{
		r = g = b = 0;
		for(s=0; s<EKRANOW; s++)
			{
			if ( scr_on & (1<<s) )
				{
				if ( !r && !g && !b )		// Jeli ju co byo "narysowane" to nie nadpisuj innych danych
					{						// W konsekwencji warstwa o niszym numerze ma wyszy priorytet i zasania warstwy nizsze
					barwa = Ekran[s][x];
					jaskrawosc = (Ekran[s][x] & 0b00011111) ^ 0b00011111;
					#ifndef GAMMA_OFF
					  if( barwa & SCR_RED ) r=Gamma[jaskrawosc];
					  if( barwa & SCR_GREEN ) g=Gamma[jaskrawosc];
					  if( barwa & SCR_BLUE ) b=Gamma[jaskrawosc];
					#else
					  if( barwa & SCR_RED ) r=jaskrawosc << 3;
					  if( barwa & SCR_GREEN ) g=jaskrawosc << 3;
					  if( barwa & SCR_BLUE ) b=jaskrawosc << 3;
					#endif
					}
				}
			}
		WS2812B_transcodeRGB( r, g, b, scr+x*8 );
		}
}


//----------------------------------------------------------------------//
void Refresh()
{
	_delay_us(50);
	pozScr = 1; UDR1 = *scr;
}


//----------------------------------------------------------------------//
//	Przewija zawarto ekrany z zapetleniem
//----------------------------------------------------------------------//
void DWrol_Ekran( byte scr )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );


	Ekran[scr][WSLED] = Ekran[scr][0];		// Do niewidocznego bufora zawarto komrki 0
	for(byte x=0; x<WSLED; x++)
		{
		Ekran[scr][x] = Ekran[scr][x+1];
		}
}


//----------------------------------------------------------------------//
//	Przewija zawarto ekranu bez zapetlenia (dane poza ekranem gin)
//----------------------------------------------------------------------//
void DW_Ekran( byte scr )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );


	for(byte x=0; x<WSLED; x++)
		{
		Ekran[scr][x] = Ekran[scr][x+1];
		}
	Ekran[scr][WSLED-1] = 0;
}


//----------------------------------------------------------------------//
//	Przewija zawarto ekranu z zapetleniem
//----------------------------------------------------------------------//
void UProl_Ekran( byte scr )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );


	for(byte x=WSLED-1; x>0; x--)
		{
		Ekran[scr][x+1] = Ekran[scr][x];
		}
	Ekran[scr][1] = Ekran[scr][0];	// Odlicza do 0 a nie -1 wic trzeba przepisa "rcznie" ostatnia pozycj
	Ekran[scr][0] = Ekran[scr][WSLED];
}


//----------------------------------------------------------------------//
//	Przewija zawarto ekranu bez zapetlenia (dane poza ekranem gin)
//----------------------------------------------------------------------//
void UP_Ekran( byte scr )
{
	if( scr >= EKRANOW ) Error( ERR_SCR );


	for(byte x=WSLED-1; x>0; x--)
		{
		Ekran[scr][x+1] = Ekran[scr][x];
		}
	Ekran[scr][1] = Ekran[scr][0];	// Odlicza do 0 a nie -1 wic trzeba przepisa "rcznie" ostatnia pozycj
	Ekran[scr][0] = 0;;
}


//----------------------------------------------------------------------//
void WS2812B_transcodeRGB(uint8_t red, uint8_t green, uint8_t blue, byte *buffer)   //Przekonwertuj podany kolor w formacie GRB na cig 8 bajtw dla USART
{
	for(byte x=0; x<8; x++) *(buffer+x) = 0b1011011;	// Czycimy bufor

//									     EccBBBaaS
//									    0b1011011;	// Off
//									    0b0010010;	// On
//								 			   ***
	if ( green & 0x80 ) *(buffer+0) &= (0b1111110);
//										    ***
	if ( green & 0x40 ) *(buffer+0) &= (0b1110011);
//									    ***
	if ( green & 0x20 ) *(buffer+0) &= (0b0011111);
	if ( green & 0x10 ) *(buffer+1) &= (0b1111110);
	if ( green & 0x08 ) *(buffer+1) &= (0b1110011);
	if ( green & 0x04 ) *(buffer+1) &= (0b0011111);
	if ( green & 0x02 ) *(buffer+2) &= (0b1111110);
	if ( green & 0x01 ) *(buffer+2) &= (0b1110011);

	if ( red   & 0x80 ) *(buffer+2) &= (0b0011111);
	if ( red   & 0x40 ) *(buffer+3) &= (0b1111110);
	if ( red   & 0x20 ) *(buffer+3) &= (0b1110011);
	if ( red   & 0x10 ) *(buffer+3) &= (0b0011111);
	if ( red   & 0x08 ) *(buffer+4) &= (0b1111110);
	if ( red   & 0x04 ) *(buffer+4) &= (0b1110011);
	if ( red   & 0x02 ) *(buffer+4) &= (0b0011111);
	if ( red   & 0x01 ) *(buffer+5) &= (0b1111110);

	if ( blue  & 0x80 ) *(buffer+5) &= (0b1110011);
	if ( blue  & 0x40 ) *(buffer+5) &= (0b0011111);
	if ( blue  & 0x20 ) *(buffer+6) &= (0b1111110);
	if ( blue  & 0x10 ) *(buffer+6) &= (0b1110011);
	if ( blue  & 0x08 ) *(buffer+6) &= (0b0011111);
	if ( blue  & 0x04 ) *(buffer+7) &= (0b1111110);
	if ( blue  & 0x02 ) *(buffer+7) &= (0b1110011);
	if ( blue  & 0x01 ) *(buffer+7) &= (0b0011111);
}


//======================================================================//
// !!! UWAGA !!!!
// Wszystkie inne przerwania musz byc nie blokowane (INTERRUPT)
//----------------------------------------------------------------------//
#define INT_NAKED				// Wcza wstawk ASM dla USART1_TX_vect
								// Przy zmianach w w/w procedurze konieczne moe by zmodyfikowanie wstawki
								// Tak samo modyfikacja moe byc konieczna przy kompilacji dla procesorw z ROM ponad 64KB (RAMPZ)
#ifdef	INT_NAKED
ISR( USART1_TX_vect, ISR_NAKED )
{
//PORTB |= _BV(PB4);
//Wywalona operacja na niewuywanym R1 (-4 rozkazy) i R0 (-6 rozkazw)
asm volatile (
//	"push	r1		\n\t"
//	"push	r0		\n\t"
//	"in	r0, 0x3f	\n\t"	// SREG
//	"push	r0		\n\t"
//	"eor	r1, r1	\n\t"
	"push	r18		\n\t"
//SREG na stos przy uyciu uywanego pniej R18 (+3)
//czna oszczdno 7 rozkazw/cykli *-4-6)+3 ma do due znaczenie z racji bardzo czstego wywoywania przerwa
	"in	r18, 0x3f	\n\t"	// SREG
	"push	r18		\n\t"
//Dalej jak wczeniej
	"push	r24		\n\t"
	"push	r25		\n\t"
	"push	r30		\n\t"
	"push	r31		\n\t"
	);
#else
SIGNAL(USART1_TX_vect)
{
#endif
//PORTB |= _BV(PB4);

	if ( pozScr )
		{
		UDR1 = *(scr+pozScr++);
		if( pozScr>=SCRLEN ) pozScr=0;
		}
	if ( pozScr >= SCRLEN ) FL_TransEnd=true;


#ifdef	INT_NAKED
asm volatile (
	"pop	r31		\n\t"
	"pop	r30		\n\t"
	"pop	r25		\n\t"
	"pop	r24		\n\t"
//Dodane SREG przy uyciu R18
	"pop	r18		\n\t"
	"out	0x3f, r18\n\t"
//Dalej normalnie R18
	"pop	r18		\n\t"
//Wywalone operacje na R0 i R1
//	"pop	r0		\n\t"
//	"out	0x3f, r0\n\t"
//	"pop	r0		\n\t"
//	"pop	r1		\n\t"
	);
//PORTB &= ~_BV(PB4);
	reti();
#endif
//PORTB &= ~_BV(PB4);
}


//======================================================================//
//     Init timera dla irq                                       		//
//----------------------------------------------------------------------//
void InitTimer0()
{
	//--- Init timera w trybie 0 ---
//	TCCR0 = 0x7;      				// Preskaler na 1024
//	TIMSK |= ( 1<<TOIE0 );    		// Zezwolenie na IRQ od przepenienia timera

	//--- Init timera w trybie CTC ---
	TCCR0A = (1<<WGM01);			// tryb CTC
	TCCR0B |= 0x5;					// Preskaler na 1024
//	OCR0A = 14; 		    	   	// Zaadowanie timera ok 1ms: TCNT0 = 1 / (14'745'600Hz / 1024 / 14) = ~1ms
	OCR0A = 1 * F_CPU/1000 / 1024;	// 1ms * F_CPU/1000 / PRESKALER
	TIMSK0 |= ( 1<<OCIE0A ); 	   	// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//     Obsuga IRQ od timera 0 (tryb CTC)                               //
//																		//
// Przerwanie co:					1ms (1000us)						//
//----------------------------------------------------------------------//
INTERRUPT(TIMER0_COMPA_vect)
{
byte static jasnosc, div, TimRefresh=2, FL_ref=false;


	if ( TimerDemo ) TimerDemo--;
	for(byte x=0; x<EKRANOW; x++) if ( TimScr[x] ) TimScr[x]--;


	if ( !TimRefresh-- )
		{
		TimRefresh = 50;			// Odwierzanie co xx ms
		if ( FL_TransEnd )
			{
			if( !FL_ref )
				{
				FL_ref = true;
				}
			else
				{
				FL_ref = false;
				FL_Refresh = true;
				#ifndef MAIN_REFRESH
				  Refresh();		// Jeli transmisja nie skoczona to nie odwierzaj
				#endif
				}
			}
		}


	//----- Pulsowanie LED -----//
	if ( !(jasnosc & 0x80) )
		{
		OCR1A = jasnosc<<1;
		}
	else
		{
		OCR1A = (jasnosc ^ 0x7F)<<1;
		}
	div++; if ( !(div & 3) ) jasnosc++;
}


//======================================================================//
//     Init timera dla irq                                       		//
//----------------------------------------------------------------------//
void InitTimer2()
{
return;
	//--- Init timera w trybie CTC ---
	TCCR2A = (2<<WGM21);				// tryb CTC
	TCCR2B |= 0x1;						// Preskaler na 1
	OCR2A = 220; 		    	   		// Zaadowanie timera 11us
//	OCR2A = 11 * F_CPU/1000000 / 1;		// 1ms * F_CPU/1000 / PRESKALER
#ifdef DMX_ON
	TIMSK2 |= ( 1<<OCIE2A ); 	   		// Zezwolenie na IRQ od porwnania timera
#endif
}


//----------------------------------------------------------------------//
//     Obsuga IRQ od timera 0 (tryb CTC)                               //
//																		//
// Przerwanie co:					1ms (1000us)						//
//----------------------------------------------------------------------//
INTERRUPT(TIMER2_COMPA_vect)
{
byte static div=4;


 PORTA |= _BV(PA2);
	if( !div--)
		{
		div=3;
//	dekoduj_dmx();
_delay_us(5);

		}
 PORTA &= ~_BV(PA2);
}


//----------------------------------------------------------------------//
void dekoduj_dmx()
{
//byte static CntDanych;
byte UsartStatus, UsartDana;
byte x, temp;


	if ( !(UCSR0A & (1<<RXC0)) ) return;		// Jeli nie ma znaku to wyjd z funkcji
	UsartStatus = UCSR0A;
	UsartDana = UDR0;


	if ( (UCSR0A & (1<DOR0)) ){ return( OVERRUNERR ); }		// Sprawdzenie przepenienia bufora FIFO
		{
TRAP;
		}
	if ( (UsartStatus & (1<<FE0)) )				// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		DmxStatus = DMX_BREAK;					// Ustaw status
		CntDanych = 0;							// Zeruj licznik danych
		if ( dmx[ 0 ] )							// Jeli CS rny od zera
			{
//			LedErrBUS();
TRAP;
			}
		else									// Jeli CS rwny zero
			{
/*
			TimerDmx = OVERTIME_DMX;
			for(x=0; x<LENTABDATA; x++)			// Przepisanie danych z tablicy DMX do tablicy PWM
				{
				temp = dmx[ x + AdrDMX ];		// Zapamitujemy dan
				if ( ! RdCfgSingle() )			// Jeli jest zwora
					{
					TabPwm[ x ] = temp;			// Przepisujemy wynik do tablicy PWM
					}
				if ( lastDana[ x ] == temp )	// Jeli poprzednia dana taka sama jak odczytana teraz
					{
					TabPwm[ x ] = temp;			// Przepisujemy wynik do tablicy PWM
					Err=MAXERR;					// Kasujemy bdy
					}
				else							// Porwnanie bdne
					{
					if ( !Err-- )
						{
						LedErrBUS();			// Licznymy bdy i sygnalizujemy
						TRAP;
						}
					}
				lastDana[ x ] = temp;			// Zapamitaj do nastpnego porwnania
				}
*/
			}
		return;
		}
	else if(DmxStatus == DMX_BREAK)				// Jesli byl BREAK i pojawila sie nowa dana:
		{
//		LedStEor();
		if ( CntDanych>=513 )
			{
			 DmxStatus=DMX_OFFLINE;
TRAP;
			  return;
			   }// Jesli za duzo danych
		if ( CntDanych<LENTABDATA )
			{
	dmx[CntDanych]=UsartDana;
	CntDanych++;
			}
		}
}


//======================================================================//
