

//	(C) 2017 R-MIK Sawomir Skrzyski
//	slawomir.skrzynski@ep.com.pl


#define	sprintf_dsname	sprintf_DsName


//======================================================================//
byte sprintf_DsName( char *txt, byte typ );


//======================================================================//
byte sprintf_DsName( char *txt, byte typ )
{
	if ( typ == 0xFF )
		{
		strcpy_P( txt, PSTR( "Alert  " ) ); return( FALSE );
		}


	switch( typ )
		{
		case( 0x01 ): strcpy_P( txt, PSTR( "DS1990A" ) );	break;
		case( 0x02 ): strcpy_P( txt, PSTR( "DS1991 " ) );	break;	// lub DS1425"
		case( 0x04 ): strcpy_P( txt, PSTR( "DS1994 " ) );	break;
		case( 0x05 ): strcpy_P( txt, PSTR( "DS2405 " ) );	break;
		case( 0x06 ): strcpy_P( txt, PSTR( "DS1993 " ) );	break;
		case( 0x08 ): strcpy_P( txt, PSTR( "DS1992 " ) );	break;
		case( 0x09 ): strcpy_P( txt, PSTR( "DS1982 " ) );	break;	// lub DS2502
		case( 0x0A ): strcpy_P( txt, PSTR( "DS1995 " ) );	break;
		case( 0x0B ): strcpy_P( txt, PSTR( "DS1985 " ) );	break;	// lub DS2505
		case( 0x0C ): strcpy_P( txt, PSTR( "DS1996 " ) );	break;
		case( 0x0F ): strcpy_P( txt, PSTR( "DS1986 " ) );	break; 	// lub DS2506
		case( 0x10 ): strcpy_P( txt, PSTR( "DS1920 " ) );	break;	// lub DS1820, DS18S20
		case( 0x12 ): strcpy_P( txt, PSTR( "DS2406 " ) );	break;	// lub DS2407
		case( 0x14 ): strcpy_P( txt, PSTR( "DS1971 " ) );	break;	// lub DS2430A
		case( 0x18 ): strcpy_P( txt, PSTR( "DS1963S" ) );	break;
		case( 0x1A ): strcpy_P( txt, PSTR( "DS1963L" ) );	break;
		case( 0x1C ): strcpy_P( txt, PSTR( "DS28E04" ) );	break;
		case( 0x1D ): strcpy_P( txt, PSTR( "DS2423 " ) );	break;
		case( 0x1F ): strcpy_P( txt, PSTR( "DS2409 " ) );	break;
		case( 0x20 ): strcpy_P( txt, PSTR( "DS2450 " ) );	break;
		case( 0x21 ): strcpy_P( txt, PSTR( "DS1921x" ) );	break;
		case( 0x22 ): strcpy_P( txt, PSTR( "DS1822 " ) );	break;
		case( 0x23 ): strcpy_P( txt, PSTR( "DS1973 " ) );	break;	// lub DS2433
		case( 0x24 ): strcpy_P( txt, PSTR( "DS1904 " ) );	break;	// lub DS2415
		case( 0x26 ): strcpy_P( txt, PSTR( "DS2438 " ) );	break;
		case( 0x27 ): strcpy_P( txt, PSTR( "DS2417 " ) );	break;
		case( 0x28 ): strcpy_P( txt, PSTR( "DS18B20" ) );	break;
		case( 0x29 ): strcpy_P( txt, PSTR( "DS2408 " ) );	break;
		case( 0x2C ): strcpy_P( txt, PSTR( "DS2890 " ) );	break;
		case( 0x2D ): strcpy_P( txt, PSTR( "DS2431 " ) );	break;
		case( 0x30 ): strcpy_P( txt, PSTR( "DS2760 " ) );	break;
		case( 0x33 ): strcpy_P( txt, PSTR( "DS1961S" ) );	break;	// lub DS2432
		case( 0x37 ): strcpy_P( txt, PSTR( "DS1977 " ) );	break;
		case( 0x3A ): strcpy_P( txt, PSTR( "DS2413 " ) );	break;
		case( 0x41 ): strcpy_P( txt, PSTR( "DS1922L" ) );	break;	// lub DS1923, DS2422
		default:
			{
			strcpy_P( txt, PSTR( "Unkown " ) );
			return( FALSE );
			}
		}


	return( TRUE );
}


//======================================================================//

