

//	(C) 2017 R-MIK Sawomir Skrzyski
//	slawomir.skrzynski@ep.com.pl


#ifndef USART0_H_
#define	USART0_H_


//------------------------------------------------------------------//
#if defined( USART0_IRQRX ) && !defined( USART0_RXBUF )
  #define	USART0_RXBUF	16			// ! Potega dwjki
  #warning "Domyslny bufor RX usart0"
#endif
#if defined( USART0_IRQTX ) && !defined( USART0_TXBUF )
  #define	USART0_TXBUF	16			// ! Potega dwjki
  #warning "Domyslny bufor TX usart0"
#endif


#ifdef USART0_IRQRX
  byte volatile Usart0_PtrRxR=0;		// Wskanik na nastpny znak
  byte volatile Usart0_PtrRxW=0;		// Wskanik znaku do zapisania
  #if USART0_BITS==9
	word Usart0_RxBuf[USART0_RXBUF];
  #else
	byte Usart0_RxBuf[USART0_RXBUF];
  #endif
#endif

#ifdef USART0_IRQTX
  byte volatile Usart0_PtrTxR=0;		// Wskanik na nastpny znak
  byte volatile Usart0_PtrTxW=0;		// Wskanik znaku do zapisania
  #if USART0_BITS==9
	word Usart0_TxBuf[USART0_TXBUF];
  #else
	byte Usart0_TxBuf[USART0_TXBUF];
  #endif
#endif


extern void Usart0_Init();
extern void Usart0_Transmit(word c );	// Bez IRQ
extern word Usart0_Receive();			// Bez IRQ
extern char Usart0_Test();
extern void Usart0_Flush();
extern word Usart0_Get();				// z i bez IRQ
extern byte Usart0_Put( word c )	;	// z i bez IRQ


//------------------------------------------------------------------//
#endif

